Qore::BinaryOutputStream Class Reference

This class implements the OutputStream interface for writing bytes to a Binary buffer. More...

Inheritance diagram for Qore::BinaryOutputStream:
[legend]

## Public Member Functions

nothing | close ()
| Closes the output stream and releases any resources. More...
| constructor ()
| Creates the BinaryOutputStream.
binary | getData ()
| Returns the data written to the stream, clearing the internal buffer. More...
nothing | write (binary data)
| Writes bytes to the output stream. More...
Public Member Functions inherited from Qore::OutputStream
| constructor ()
| Constructor. More...

## Detailed Description

This class implements the OutputStream interface for writing bytes to a Binary buffer.

Example: BinaryOutputStream basic usage
  BinaryOutputStream bos();
  bos.write(<0405>);
  bos.write(<06>);
  bos.getData(); # returns <040506>

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown.

See also
  StreamWriter for a class that can be used to write various kinds of data to an OutputStream

Since
  Qore 0.8.13

## Member Function Documentation

## close()

nothing Qore::BinaryOutputStream::close | ( |  | ) |

virtual

Closes the output stream and releases any resources.

Any methods called on a closed output stream will throw an exception.

Implements Qore::OutputStream.

## getData()

binary Qore::BinaryOutputStream::getData | ( |  | ) |

Returns the data written to the stream, clearing the internal buffer.

Returns
  the data written to the BinaryOutputStream

Example:
  BinaryOutputStream bos();
  bos.write(<0405>);
  bos.write(<06>);
  bos.getData(); # returns <040506>

Exceptions

  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

## write()

nothing Qore::BinaryOutputStream::write | ( | binary | data | ) |

virtual

Writes bytes to the output stream.

Parameters

  data | the data to write

Example:
  BinaryOutputStream bos();
  bos.write(<0405>);
  bos.write(<06>);
  bos.getData(); # returns <040506>

Exceptions

  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::OutputStream.